local mod = RW:Boss("Shazzrah", "Classic" , "Molten Core")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_ragnaros]]

---------------------------
-- Variables

-- Blink
local tBlinkCD, wBlink
-- Buff
local tBuffCD, wBuff
-- Curse
local tCurseCD, wCurse, mCurse

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger()
	self:SetWin()
	
	-- Blink
	tBlinkCD	= self:CDTimer(45, 23138)
	wBlink		= self:CastWarning(23138)
	
	-- Buff
	tBuffCD		= self:CDTimer(30, 19714)
	wBuff		= self:CastWarning(19714)
	
	-- Curse
	tCurseCD	= self:CDTimer(30, 19713)
	wCurse		= self:OnYouWarning(19713)
	mCurse		= self:TargetMessage(19713)
end

---------------------------
-- Locals

-- API Functions

function mod:OnEngage(trigger)
	self:Track("Blink", 23138)
	self:Track("Buff", 19714)
	self:Track("Curse", 19713)
end

function mod:Blink(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tBlinkCD:Start()
		wBlink:Show()
	end
end

function mod:Buff(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tBuffCD:Start()
		wBuff:Show()
	end
end

function mod:Curse(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tCurseCD:Start()
		
	elseif event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wCurse:Show()
		end
		mCurse:AddDelayTarget(args.dName)
		mCurse:DelayedShow(0.3)
	end
end